/*
 * AssociationExtractorQuis.java
 */

package tm4jweb.ferdig;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.TopicMapWalker;
import org.tm4j.topicmap.utils.XTMWriter;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;


public class AssociationExtractorQuis{


    public BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();
	public TopicMap tm = null;

    OccurrencesExtractor occurrencesExtractor = new OccurrencesExtractor();
	SerializedTopicMapSource serializedSource;

	public String[] assTypes;
	public String[] ids;

	ArrayList assTypesArrayList;
    Collection topicNameCollection;
	String src;

    File outfile, outfile2;
	File sourceFile;
	FileOutputStream os;


	public void openStream(){
		//Creating OutputStream for printing the results
      	try{
	      	outfile = new File("c:/diplom/egne eksempler/test2.xtm");
	      	outfile2 = new File("c:/diplom/egne eksempler/testavimport2.txt");
	      	os = new FileOutputStream(outfile);
		}
		catch(java.lang.NullPointerException ex){
			System.err.println(ex.toString());
		}
		catch(FileNotFoundException ex){
			System.err.println(ex.toString());
		}
	}

	// Load the "source" topic map into memory
	public void importer(String source){

		try{
			src = source;
			sourceFile = new File(src);
			serializedSource = new SerializedTopicMapSource(sourceFile);
			 TopicMapProviderFactory tmpf = TopicMapProviderFactory.newInstance();
			 TopicMapProvider provider = tmpf.newTopicMapProvider(System.getProperties());
			 tm = provider.addTopicMap(serializedSource);
		 }

		catch(TopicMapProviderFactoryConfigurationError ex){
		 	System.err.println("Error in specification of provider factory: " + ex.toString());
		}

		catch(TopicMapProviderException ex){
			System.err.println("Error creating back-end connection: " + ex.toString());
		}

		catch(FileNotFoundException ex){
			System.err.println("File not found");
		}

		catch(MalformedURLException ex){
			System.err.println("MalformedURL");
		}

	return;
	}


	public void writeTopicMap(TopicMap tm, OutputStream os)
	{
		TopicMapWalker walker = new TopicMapWalker();
		XTMWriter writer = new XTMWriter();
		OutputFormat of = new OutputFormat();
		of.setEncoding("UTF-8");
		of.setIndenting(true);
		of.setIndent(2);
		XMLSerializer serializer = new XMLSerializer(os, of);
		walker.setHandler(writer);
		writer.setContentHandler(serializer);
		try{
		    walker.walk(tm);}
		catch(TopicMapProcessingException ex){
		    throw new RuntimeException("Unable to write topic map." + ex.toString());
		}
    }

	// Use extractAssociation() to get associations and association types.
	// Store these in class variables.
	public void writeAssociation(){
		ExtractAssociation ea = new ExtractAssociation();
		ea.extractAssociation(tm);
		assTypesArrayList = ea.getTypes();
		ids = ea.getIds();
	}

	// Get association types
	public String[] getTypes(){
		return assTypes;
	}

	// For test purpose
	public ArrayList getTypesArrayList(){
		return assTypesArrayList;
	}

	// Get associations
	public String[] getIds(){
		return ids;
	}

	// Get associations of a specific type
	public String[] extractAssOfType(String type){
		ExtractAssociation ea = new ExtractAssociation();
		ea.extractAssociationsOfType(tm, type);
		String[] results = ea.getAssOfType();
		return results;
	}

	// For test purposes
	public void printAssOfType(){
		String[] test = extractAssOfType("Superclass-Subclass");
		int d = java.lang.reflect.Array.getLength(test);
		System.out.println("Results from \"printAssOfType\": ");
		for(int f = 0;f<d;f++){
			System.out.println(test[f]);
		}
	}

	// For test purposes
	public static void main(String[] args){
		AssociationExtractorQuis aeq = new AssociationExtractorQuis();
		aeq.openStream();
		try{
			aeq.importer(args[0]);
			aeq.writeAssociation();
			aeq.printAssOfType();
		}
		catch(ArrayIndexOutOfBoundsException e){
			System.out.println("Remember topic map argument...");
		}
	}
}
