/**
 * ExtractTopic.java
 */

package tm4jweb.ferdig;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.*;

import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.*;
import org.tm4j.topicmap.*;
import org.tm4j.net.*;


public class ExtractAssociation{

	// Local topic map
    TopicMap tm;

    // Temporary variables for extracted topics
    Topic topicInArray;

    // Association extracter from iterator
    Association assFromIterator;

	// Used to retrieve association base names
    AssociationNameExtractor associationNamesExtractor = new AssociationNameExtractor();

	// Used to retrieve topic base names
	BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();

	// Iterators over the topic map's associations and topics
    Iterator associationIterator, topicsIterator;

    Collection associationCollection, topicNameCollection;

    int i = 0;
    int j = 0;
    int numberOfAssociations, topics;
	int numberOfAssociationsOfType = 0;

	// ArrayList for the different association types
    ArrayList assTypeArrayList = new ArrayList();

	String[] associationIdStrings;
    String[] assTypesString;
    String[] results;

    Set anotherSet;

    Topic topic, topicType;

    String topicName;

	// constructor
    public ExtractAssociation(){
		System.out.println("ExtractTopic created");
	}

	// Get the associations of a specific type in a topic map
    public void extractAssociationsOfType(TopicMap map, String type){

		tm = map;
		anotherSet = tm.getTopics();
		System.out.println("Set size = " + anotherSet.size());
		topics = tm.getTopicCount();
		topicsIterator = anotherSet.iterator();

		while(topicsIterator.hasNext()){

			topic = (Topic)topicsIterator.next();

			topicNameCollection = (Collection)baseNamesExtractor.fn(topic);

			Object[] objectArray3 = topicNameCollection.toArray();

			if(java.lang.reflect.Array.getLength(objectArray3) == 0){
				topicName = "No Name";
			}

			else{
				topicName = ((BaseName)(objectArray3[0])).getData();
			}

			if(topicName.compareTo(type) == 0){
				topicType = topic;
			}

		}



		associationIterator = tm.getAssociationsIterator();
		associationCollection = tm.getAssociations();
		numberOfAssociations = associationCollection.size();
		associationIdStrings = new String[numberOfAssociations];

		while(associationIterator.hasNext()){
			assFromIterator = (Association)associationIterator.next();
			if(assFromIterator.isOfType(topicType)){
				numberOfAssociationsOfType++;
				String nameofass = assFromIterator.getID();
				associationIdStrings[j] = nameofass;
				j++;
			}
		}
		if(j==0){
			results = new String[1];
			results[0] = "no hits";
		}
		else{
			results = new String[j];
		}

		for(int k=0;k<j;k++){
			results[k] = associationIdStrings[k];
		}

	}

	public String[] getAssOfType(){
		return results;
	}

	// Save the topic map associations in a class variable
    public void extractAssociation(TopicMap map) {

		tm = map;

		associationIterator = tm.getAssociationsIterator();
		associationCollection = tm.getAssociations();
        numberOfAssociations = associationCollection.size();
		System.out.println("Number of associations: " + numberOfAssociations);
		associationIdStrings = new String[numberOfAssociations];

		while(associationIterator.hasNext()){

			assFromIterator = (Association)associationIterator.next();

			String nameofass = assFromIterator.getID();
			associationIdStrings[i] = nameofass;

			Object assName = associationNamesExtractor.fn(assFromIterator);
			String aa = (String)assName;
			if(!assTypeArrayList.contains(aa)){
				assTypeArrayList.add(aa);
			}
			i++;
		}

		printResults(associationIdStrings, assTypeArrayList);

	}

	// For test use
	public void printResults(String[] ids, ArrayList types){
		for(int j=0; j<Array.getLength(ids); j++){
			System.out.println("Association ID: " + ids[j]);
		}

		for(int j=0; j<types.size();j++){
			System.out.println("Association type: " + types.get(j));
		}
	}

	// Get the association types
	public ArrayList getTypes(){
		return assTypeArrayList;
	}

	// Get the associations
	public String[] getIds(){
		return associationIdStrings;
	}

}
