package tm4jweb.ferdig;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.TopicMapWalker;
import org.tm4j.topicmap.utils.XTMWriter;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;


public class TopicExtractorQuis{

	// Class variables

    public BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();
	public TopicMap tm = null;

    OccurrencesExtractor occurrencesExtractor = new OccurrencesExtractor();
	SerializedTopicMapSource serializedSource;

    Collection topicNameCollection;

    File outfile, outfile2;
	File sourceFile;
	FileOutputStream os;

	String src;

	String[] testStringArray;
	String[] topicTypesReturnArray;
	String[] extractedTopics;

	public void openStream(){
		//Creating OutputStream for printing the results
      	try{
	      	outfile = new File("c:/diplom/egne eksempler/test2.xtm");
	      	outfile2 = new File("c:/diplom/egne eksempler/testavimport2.txt");
	      	os = new FileOutputStream(outfile);
		}
		catch(java.lang.NullPointerException ex){
			System.err.println(ex.toString());
		}
		catch(FileNotFoundException ex){
			System.err.println(ex.toString());
		}
	}

	// Load the "source" topic map into memory
	public void importer(String source){
		try{
			src = source;
			sourceFile = new File(src);
			serializedSource = new SerializedTopicMapSource(sourceFile);
			 TopicMapProviderFactory tmpf = TopicMapProviderFactory.newInstance();
			 TopicMapProvider provider = tmpf.newTopicMapProvider(System.getProperties());
			 tm = provider.addTopicMap(serializedSource);
		 }

		catch(TopicMapProviderFactoryConfigurationError ex){
		 	System.err.println("Error in specification of provider factory: " + ex.toString());
		 }

		catch(TopicMapProviderException ex){
			System.err.println("Error creating back-end connection: " + ex.toString());
		}

		catch(FileNotFoundException ex){
			System.err.println("File not found");
		}

		catch(MalformedURLException ex){
			System.err.println("MalformedURL");
		}
	return;
	}

	public void writeTopicMap(TopicMap tm, OutputStream os)
	{
		TopicMapWalker walker = new TopicMapWalker();
		XTMWriter writer = new XTMWriter();
		OutputFormat of = new OutputFormat();
		of.setEncoding("UTF-8");
		of.setIndenting(true);
		of.setIndent(2);
		XMLSerializer serializer = new XMLSerializer(os, of);
		walker.setHandler(writer);
		writer.setContentHandler(serializer);
		try
		{
		    walker.walk(tm);
		}
		catch(TopicMapProcessingException ex)
		{
		    throw new RuntimeException("Unable to write topic map." + ex.toString());
		}
    }

	// Get the topics in a topic map and add their names to the String[] "testStringArray"
	// Get the topic types in a topic map and add their names to the String "topicTypesReturnArray"
	public void writeTopics(){

		// The collection of names is done in a "ExtractTopic" object
		ExtractTopic et = new ExtractTopic();
		String[] topicArr = et.extractTopic(tm);
		String[] topicTypes = et.getTopicTypes();

		// For test purposes
		int j = java.lang.reflect.Array.getLength(topicArr);
		int topicTypesLength = java.lang.reflect.Array.getLength(topicTypes);
		for(int k=0;k<j;k++){
			System.out.println(topicArr[k]);
		}

		// Copy the arrays to the class variables
		testStringArray = topicArr;
		topicTypesReturnArray = topicTypes;

		// For test purposes
		System.out.println("Topic types: ");
		for(int m=0;m<topicTypesLength;m++){
			System.out.print("Topic type:  ");
			System.out.println(topicTypes[m]);
		}

	}

	// Get the topics of a specific type and return them in a String[]
	public String[] extractTopicsOfType(String topicType){
		System.out.println(topicType + "ddd");
		ExtractTopic et = new ExtractTopic();
		String[] topicArr = et.extractTopic(tm);
		String[] topicsOfType = et.extractTopicsOfType(tm, topicType);
		//ArrayList a = et.extractTopicProps(tm, "Ontopia");
		//printOccurrences(a);
		return topicsOfType;
	}

	// Get the characteristics of a specific topic and return them in an ArrayList
	public ArrayList extractTopicProps(String topicPropsTopic){
		ExtractTopic et = new ExtractTopic();
		ArrayList a = et.extractTopicProps(tm, topicPropsTopic);
		return a;
	}

	public void printOccurrences(ArrayList occ){
		String[] sArray = (String[])occ.get(0);
		String[] sArray2 = (String[])occ.get(1);
		String[] sArray3 = (String[])occ.get(2);
		System.out.println(sArray[0]);
		System.out.println(sArray2[0]);
		System.out.println(sArray3[0]);
	}

	// Returns the topics
	public String[] getTopics(){
		return testStringArray;
	}

	// Returns the topic types
	public String[] getTopicTypes(){
		return topicTypesReturnArray;
	}

	// For test purposes
	public void printTopicsOfType(){
		String[] results = extractTopicsOfType("Developer");
		int lokalInt = java.lang.reflect.Array.getLength(results);
		System.out.println("Number of results = " + lokalInt);
		for(int s = 0;s<lokalInt;s++){
			System.out.println(results[s]);
		}

	}

	// For test purposes
	public static void main(String[] args){
		TopicExtractorQuis teq = new TopicExtractorQuis();
		teq.openStream();

		try{

			teq.importer(args[0]);
			teq.printTopicsOfType();
		}

		catch(ArrayIndexOutOfBoundsException e){
			System.out.println("Remember topic map argument...");
		}

	}

}
