/**
 * AddAssociation.java
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.Array;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.TopicMapWalker;
import org.tm4j.topicmap.utils.XTMWriter;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;




public class AddAssociation implements ActionListener {

	// Class variables

   	JComboBox member1, member2, member1Extracted, member2Extracted, assType;
   	JComboBox member1Role, member1RoleExtracted, member2Role, member2RoleExtracted, assTypeExtracted;
   	JFrame addAssociationFrame;
    JPanel addAssociationPanel;
    JButton exitButton, addAssButton;
    JTextField assNameField;
    JLabel assNameLabel, assAddedLabel,member1NameLabel,member1RoleNameLabel;
    JLabel member2NameLabel, member2RoleNameLabel, assTypeLabel;

    TopicMap tm;
    Topic topicInArray;
    Topic chosenTopic;
    Topic member1Topic,member2Topic,member1RoleTopic,member2RoleTopic, assTypeTopic;
    Association association;
    BaseName topicBaseName;
    BaseName testBaseName;
    BaseName nyTestBaseName;
    BaseName nyTestBaseName2;
    TopicNameExtractor topicNameExtractor = new TopicNameExtractor();
    BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();
    Member member1Member, member2Member;

    File outfile;
    FileOutputStream os;

    Set topicSet;
    ArrayList topicArrayList;
    Collection topicNameCollection;
    Collection topicAssociationCollection;
    Collection topicAssociationCollection2;
    String member1Chosen = null;
    String member2Chosen = null;
    String member1RoleChosen = null;
    String member2RoleChosen = null;
    String assTypeChosen = null;
    String baseNameString;
    int i = 0;
    int numberOfTopics, collectionSize;

    Object[] baseNameObjectArray;
    Object[] objectArray;
    String[] topicNames;

	// constructor
    public AddAssociation(){
		System.out.println("AddAssociation created");
	}

    public void assAdder(TopicMap inMap) {

		//Saving incoming map in local variable
      	tm = inMap;

      	//Creating OutputStream for printing the results
      	try{
	      	outfile = new File("c:/diplom/egne eksempler/test.xtm");
	      	os = new FileOutputStream(outfile);
		}
		catch(java.lang.NullPointerException ex){
			System.err.println(ex.toString());
		}
		catch(FileNotFoundException ex){
			System.err.println(ex.toString());
		}

      //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

      //Create and set up the window.
        addAssociationFrame = new JFrame("Add Association");
        addAssociationFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addAssociationFrame.setSize(new Dimension(240, 120));

        //Create and set up the panel.
        addAssociationPanel = new JPanel(new GridLayout(8, 2));

        //Add the widgets.
        addWidgets();

        //Set the default button.
        addAssociationFrame.getRootPane().setDefaultButton(addAssButton);

        //Add the panel to the window.
        addAssociationFrame.getContentPane().add(addAssociationPanel, BorderLayout.CENTER);

        //Display the window.
        addAssociationFrame.pack();
        addAssociationFrame.setVisible(true);
    }

    /**
     * Create and add the widgets.
     */
    public void addWidgets() {

		// See comments in "AddTopic.java"
        assNameField = new JTextField(2);
        assNameLabel = new JLabel("Type association mame", SwingConstants.LEFT);
        member1NameLabel = new JLabel("Choose member 1", SwingConstants.LEFT);
        member1RoleNameLabel = new JLabel("Choose role for member 1  ", SwingConstants.LEFT);
        member2NameLabel = new JLabel("Choose member 2", SwingConstants.LEFT);
        member2RoleNameLabel = new JLabel("Choose role for member 2  ", SwingConstants.LEFT);
        assTypeLabel = new JLabel("Choose association type: ", SwingConstants.LEFT);
        addAssButton = new JButton("Add Association");
        exitButton = new JButton("Exit");
        assAddedLabel = new JLabel("...", SwingConstants.LEFT);
        topicSet = tm.getTopics();
		numberOfTopics = tm.getTopicCount();
		System.out.println("number of topics = " + numberOfTopics);
        topicNames = new String[numberOfTopics];
        objectArray = new Object[numberOfTopics];
		objectArray = topicSet.toArray(objectArray);

		do{//while(objectArray[i]!=null)
			topicInArray = (Topic)(objectArray[i]);
			System.out.println("i = " + i);
			//Retrieving topic BaseNames
			topicNameCollection = (Collection)baseNamesExtractor.fn(topicInArray);

			//Converting Collection to Object[]
			Object[] objectArray2 = topicNameCollection.toArray();

			//Retrieving first BaseName in Object[]
			String utNavn2 = ((BaseName)(objectArray2[0])).getData();

			topicNames[i] = utNavn2;

			//Incrementing counter i, and collecting next topic from objectArray[]
			i++;

		}while(i<numberOfTopics);

        member1 = new JComboBox(topicNames);
        member1.addActionListener(this);
        member2 = new JComboBox(topicNames);
        member2.addActionListener(this);
        member1Role = new JComboBox(topicNames);
        member1Role.addActionListener(this);
        member2Role = new JComboBox(topicNames);
        member2Role.addActionListener(this);
        assType = new JComboBox(topicNames);
        assType.addActionListener(this);

        //Listen to events from the buttons.
        addAssButton.addActionListener(this);
        exitButton.addActionListener(this);

        //Add the widgets to the container.
        addAssociationPanel.add(assNameLabel);
        addAssociationPanel.add(assNameField);
		addAssociationPanel.add(member1NameLabel);
        addAssociationPanel.add(member1);
        addAssociationPanel.add(member2NameLabel);
        addAssociationPanel.add(member2);
        addAssociationPanel.add(member1RoleNameLabel);
        addAssociationPanel.add(member1Role);
        addAssociationPanel.add(member2RoleNameLabel);
        addAssociationPanel.add(member2Role);
        addAssociationPanel.add(assTypeLabel);
        addAssociationPanel.add(assType);
        addAssociationPanel.add(addAssButton);
        addAssociationPanel.add(assAddedLabel);
        addAssociationPanel.add(exitButton);


        assNameLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        assAddedLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
    }

    private Object makeObj(final String item)  {
	     return new Object() { public String toString() { return item; } };
	}


    public void actionPerformed(ActionEvent event) {
        String associationName = (String)(assNameField.getText());

        try{

			// Close window
			if(event.getSource() == exitButton){
			 	System.out.println("Closing Add Topic Window");
			   	addAssociationFrame.setVisible(false);
			}

			// Choose association type
			else if(event.getSource() == assType){
				assTypeExtracted = (JComboBox)event.getSource();
				String name = (String)assTypeExtracted.getSelectedItem();
				assTypeChosen = name;
			}

			// Choose association member 1
			else if(event.getSource() == member1){
				member1Extracted = (JComboBox)event.getSource();
				String name = (String)member1Extracted.getSelectedItem();
				System.out.println(name);
				member1Chosen = name;
			}

			// Choose association member 2
			else if(event.getSource() == member2){
				member2Extracted = (JComboBox)event.getSource();
				String name = (String)member2Extracted.getSelectedItem();
				System.out.println(name);
				member2Chosen = name;
			}

			// Choose role for member 1
			else if(event.getSource() == member1Role){
				member1RoleExtracted = (JComboBox)event.getSource();
				String name = (String)member1RoleExtracted.getSelectedItem();
				System.out.println(name);
				member1RoleChosen = name;
			}

			// Choose role for member 2
			else if(event.getSource() == member2Role){
				member2RoleExtracted = (JComboBox)event.getSource();
				String name = (String)member2RoleExtracted.getSelectedItem();
				System.out.println(name);
				member2RoleChosen = name;
			}

			// Add association
        	else{
				if((member1Chosen!=null)&&(member2Chosen!=null)&&(member1RoleChosen!=null)&&(member2RoleChosen!=null)){
					member1Topic = tm.getTopicByID(member1Chosen);
					assTypeTopic = tm.getTopicByID(assTypeChosen);
					member2Topic = tm.getTopicByID(member2Chosen);
					member1RoleTopic = tm.getTopicByID(member1RoleChosen);
					member2RoleTopic = tm.getTopicByID(member2RoleChosen);
					association = tm.createAssociation(associationName);

					Set ret = new HashSet();
					ret.add(member1Topic);
					topicAssociationCollection = Collections.unmodifiableCollection(ret);
					member1Member = association.createMember(null, null, member1RoleTopic, topicAssociationCollection);
					association.addMember(member1Member);

					Set ret2 = new HashSet();
					ret2.add(member2Topic);
					topicAssociationCollection2 = Collections.unmodifiableCollection(ret2);
					member2Member = association.createMember(null, null, member2RoleTopic, topicAssociationCollection2);
					association.addMember(member2Member);

					association.setType(assTypeTopic);

					writeTopicMap(tm,os);
					System.out.println("Association added");
				}
				else{
					System.out.println("Choose topics");
				}
			}
		}
		catch(Exception ex){
			System.err.println(ex.toString());
		}

    }

    public void writeTopicMap(TopicMap tm, OutputStream os)
    {
		TopicMapWalker walker = new TopicMapWalker();
		XTMWriter writer = new XTMWriter();
		OutputFormat of = new OutputFormat();
		of.setEncoding("UTF-8");
		of.setIndenting(true);
		of.setIndent(2);
		XMLSerializer serializer = new XMLSerializer(os, of);
		walker.setHandler(writer);
		writer.setContentHandler(serializer);
		try
		{
		    walker.walk(tm);
		}
		catch(TopicMapProcessingException ex)
		{
		    throw new RuntimeException("Unable to write topic map." + ex.toString());
		}

    }

}