/**
 * AddIntOcc.java
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.Array;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import org.tm4j.net.memory.URILocatorImpl;
import org.tm4j.net.memory.LocatorFactoryImpl;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.TopicMapWalker;
import org.tm4j.topicmap.utils.XTMWriter;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;


public class AddIntOcc implements ActionListener {

	// Class variables

   	JComboBox topicsCombo, topicsComboExtracted;
   	JComboBox occurrenceType, occurrenceTypeExtracted;
   	JComboBox extInt, extIntExtracted;
   	JFrame addIntOccFrame;
    JPanel addIntOccPanel;
    JButton exitButton, addOccButton;
    JTextField occNameField;
    JLabel occNameLabel, occAddedLabel, chosenTopicLabel, occurrenceTypeLabel,extIntLabel;

    TopicMap tm;
    Topic topicInArray;
    Topic chosenTopic;
    BaseName topicBaseName;
    BaseName testBaseName;
    BaseName nyTestBaseName;
    BaseName nyTestBaseName2;
    Occurrence occurrence;
    TopicNameExtractor topicNameExtractor = new TopicNameExtractor();
    BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();
    LocatorFactoryImpl locFac = new LocatorFactoryImpl();
    Locator loc;

    File outfile;
    FileOutputStream os;

    Set topicSet;
    ArrayList topicArrayList;
    Collection topicNameCollection;
    String chosenName = null;
    String occurrenceTypeChosen = null;
    String extIntChosenString = null;
    String baseNameString;
    int i = 0;
    int numberOfTopics, collectionSize;

    Object[] baseNameObjectArray;
    Object[] objectArray;
    String[] topicNames;

	// constructor
    public AddIntOcc(){
		System.out.println("AddIntOcc created");
	}

    public void intOccAdder(TopicMap inMap) {

		//Saving incoming map in local variable
      	tm = inMap;

      	//Creating OutputStream for printing the topic map
      	try{
	      	outfile = new File("c:/diplom/egne eksempler/test.xtm");
	      	os = new FileOutputStream(outfile);
		}
		catch(java.lang.NullPointerException ex){
			System.err.println(ex.toString());
		}
		catch(FileNotFoundException ex){
			System.err.println(ex.toString());
		}

      // Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

      // Create and set up the window.
        addIntOccFrame = new JFrame("Add Internal Occurrence");
        addIntOccFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addIntOccFrame.setSize(new Dimension(240, 120));

        // Create and set up the panel.
        addIntOccPanel = new JPanel(new GridLayout(6, 2));

        // Add the widgets.
        addWidgets();

        // Set the default button.
        addIntOccFrame.getRootPane().setDefaultButton(addOccButton);

        // Add the panel to the window.
        addIntOccFrame.getContentPane().add(addIntOccPanel, BorderLayout.CENTER);

        // Display the window.
        addIntOccFrame.pack();
        addIntOccFrame.setVisible(true);
    }


    //Create and add the widgets.

    public void addWidgets() {

		// See comments in "AddTopic.java"

        occNameField = new JTextField(2);
        occNameLabel = new JLabel("Type occurrence:", SwingConstants.LEFT);
        chosenTopicLabel = new JLabel("Select topic for occurrence: ", SwingConstants.LEFT);
        occurrenceTypeLabel = new JLabel("Select occurrence type: ", SwingConstants.LEFT);
        extIntLabel = new JLabel("Select internal og external occurrence: ", SwingConstants.LEFT);
        addOccButton = new JButton("Add Occurrence");
        exitButton = new JButton("Exit");
        occAddedLabel = new JLabel("...", SwingConstants.LEFT);
        topicSet = tm.getTopics();
		numberOfTopics = tm.getTopicCount();
		System.out.println("number of topics = " + numberOfTopics);
        topicNames = new String[numberOfTopics];
        objectArray = new Object[numberOfTopics];
		objectArray = topicSet.toArray(objectArray);

		do{
			topicInArray = (Topic)(objectArray[i]);
			System.out.println("i = " + i);
			//Retrieving topic BaseNames
			topicNameCollection = (Collection)baseNamesExtractor.fn(topicInArray);

			//Converting Collection to Object[]
			Object[] objectArray2 = topicNameCollection.toArray();

			//Retrieving first BaseName in Object[]
			String utNavn2 = ((BaseName)(objectArray2[0])).getData();

			topicNames[i] = utNavn2;

			i++;
		}while(i<numberOfTopics);

        topicsCombo = new JComboBox(topicNames);
        topicsCombo.addActionListener(this);

		occurrenceType = new JComboBox(topicNames);
		occurrenceType.addActionListener(this);

		String[] extIntChooser = new String[2];
		extIntChooser[0] = "Internal";
		extIntChooser[1] = "External";
		extInt = new JComboBox(extIntChooser);
		extInt.addActionListener(this);


        //Listen to events from the Convert button.
        addOccButton.addActionListener(this);
        exitButton.addActionListener(this);

        //Add the widgets to the container.
        addIntOccPanel.add(occNameLabel);
        addIntOccPanel.add(occNameField);
		addIntOccPanel.add(chosenTopicLabel);
        addIntOccPanel.add(topicsCombo);
        addIntOccPanel.add(occurrenceTypeLabel);
        addIntOccPanel.add(occurrenceType);
        addIntOccPanel.add(extIntLabel);
        addIntOccPanel.add(extInt);
        addIntOccPanel.add(addOccButton);
        addIntOccPanel.add(occAddedLabel);
        addIntOccPanel.add(exitButton);


        occNameLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        occAddedLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
    }

    private Object makeObj(final String item)  {
	     return new Object() { public String toString() { return item; } };
	}


    public void actionPerformed(ActionEvent event) {

        String occurrenceString = (String)(occNameField.getText());
        occAddedLabel.setText("Occurrence added...");

      	try{

			// Close window
			if(event.getSource() == exitButton){
			   	//return;
			 	System.out.println("Closing Add Occurrence Window");
			   	addIntOccFrame.setVisible(false);
			}

			// Choose topic
			else if(event.getSource() == topicsCombo){
				topicsComboExtracted = (JComboBox)event.getSource();
				String name = (String)topicsComboExtracted.getSelectedItem();
				System.out.println(name);
				chosenName = name;
			}

			// Choose occurrence type
			else if(event.getSource() == occurrenceType){
				occurrenceTypeExtracted = (JComboBox)event.getSource();
				String name = (String)occurrenceTypeExtracted.getSelectedItem();
				System.out.println(name);
				occurrenceTypeChosen = name;
			}

			// Choose external or internal occurrence
			else if(event.getSource() == extInt){
				extIntExtracted = (JComboBox)event.getSource();
				String name = (String)extIntExtracted.getSelectedItem();
				System.out.println(name);
				extIntChosenString = name;
			}

        	// Add occurrence
        	else{
				if(extIntChosenString == null){
					System.out.println("Choose external or internal occurrence!");
				}

				// Add internal occurrence
				else if(extIntChosenString == "Internal"){
					Topic occTopic = tm.getTopicByID(chosenName);
					occurrence = occTopic.createOccurrence(occurrenceString);
					occurrence.setData(occurrenceString);
					writeTopicMap(tm,os);
					System.out.println("Internal occurrence added");
				}

				// Add external occurrence
				else if(extIntChosenString == "External"){
					Topic occTopic2 = tm.getTopicByID(chosenName);
					Topic occTopicType = tm.getTopicByID(occurrenceTypeChosen);
					locFac.registerImplementation("URI","org.tm4j.net.memory.URILocatorImpl");
					loc = locFac.createLocator("URI", occurrenceString);
					Topic[] themesArray = new Topic[2];
					themesArray[0] = occTopicType;

					// For test purposes
					System.out.println("occurrenceString = " + occurrenceString);
					System.out.println("loc-notation = " + loc.getNotation());
					System.out.println("loc-address = " + loc.getAddress());
					System.out.println("occurrenceTypeChosen = "+ occurrenceTypeChosen);

					occurrence = occTopic2.createOccurrence(occurrenceString,loc,occTopicType,loc,null);
					writeTopicMap(tm,os);
					System.out.println("External occurrence added");
				}
			}
		}

		catch(Exception ex){
			System.err.println(ex.toString());
		}

    }

    public void writeTopicMap(TopicMap tm, OutputStream os)
    {
		TopicMapWalker walker = new TopicMapWalker();
		XTMWriter writer = new XTMWriter();
		OutputFormat of = new OutputFormat();
		of.setEncoding("UTF-8");
		of.setIndenting(true);
		of.setIndent(2);
		XMLSerializer serializer = new XMLSerializer(os, of);
		walker.setHandler(writer);
		writer.setContentHandler(serializer);
		try
		{
		    walker.walk(tm);
		}
		catch(TopicMapProcessingException ex)
		{
		    throw new RuntimeException("Unable to write topic map." + ex.toString());
		}

    }

}