/**
 * AddTopic2.java
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.Array;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.TopicMapWalker;
import org.tm4j.topicmap.utils.XTMWriter;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;


public class AddTopic2 implements ActionListener {

	// Class variables

    JFrame addTopicFrame;
    JPanel addTopicPanel;
    JTextField topicNameField;
    JLabel topicNameLabel, topicAddedLabel;
    JButton addTopic,exitButton;
	JComboBox topicType, topicTypeExtracted;
	JLabel topicTypeLabel;

    File outfile;
    FileOutputStream os;

    TopicMap tm;
    Topic topicInArray, topicTypeTopic, testTopic;
	BaseName baseName;
	TopicNameExtractor topicNameExtractor = new TopicNameExtractor();
    BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();

    Set topicSet;
    ArrayList topicArrayList;
    Collection topicNameCollection;

    Object[] baseNameObjectArray;
	String[] topicNames;
	Object[] objectArray;

    String baseNameString;
	String topicTypeChosen = null;
    int i = 0;
    int j = 0;
    int numberOfTopics, collectionSize;
    Boolean topicTypeSelected = false;


	// Constructor
    public AddTopic2(){
		System.out.println("AddTopic created");
	}

	// Method called from external objects
    public void topicAdder(TopicMap inMap) {

      	tm = inMap;

      	//Creating OutputStream for printing the results
      	try{
	      	outfile = new File("c:/diplom/egne eksempler/test.xtm");
	      	os = new FileOutputStream(outfile);
		}
		catch(java.lang.NullPointerException ex){
			System.err.println(ex.toString());
		}
		catch(FileNotFoundException ex){
			System.err.println(ex.toString());
		}

      //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

      //Create and set up the window.
        addTopicFrame = new JFrame("Add Topic");
        //addTopicFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        addTopicFrame.setSize(new Dimension(240, 120));

        //Create and set up the panel.
        addTopicPanel = new JPanel(new GridLayout(4, 2));

        //Add the widgets.
        addWidgets();

        //Set the default button.
        addTopicFrame.getRootPane().setDefaultButton(addTopic);

        //Add the panel to the window.
        addTopicFrame.getContentPane().add(addTopicPanel, BorderLayout.CENTER);

        //Display the window.
        addTopicFrame.pack();
        addTopicFrame.setVisible(true);
    }

    /**
     * Create and add the widgets.
     */
    public void addWidgets() {

        topicNameField = new JTextField(4);
        topicNameLabel = new JLabel("Type topic name: ", SwingConstants.LEFT);
        addTopic = new JButton("Add Topic");
     	topicTypeLabel = new JLabel("Choose topic type: ", SwingConstants.LEFT);
     	exitButton = new JButton("Exit");
        topicAddedLabel = new JLabel("...", SwingConstants.LEFT);

		// get all topics
        topicSet = tm.getTopics();

		numberOfTopics = tm.getTopicCount();
		System.out.println("number of topics = " + numberOfTopics);
		objectArray = new Object[numberOfTopics];

		// Array that will contain all topic names
		topicNames = new String[numberOfTopics];

		// Move the topics to an array
		objectArray = topicSet.toArray(objectArray);

		// Loop that adds the topic names to the array
		do{
			// Get a topic from the array
			topicInArray = (Topic)(objectArray[i]);
			System.out.println("i = " + i);

			//Retrieve the topics' BaseNames
			topicNameCollection = (Collection)baseNamesExtractor.fn(topicInArray);

			// Move the basenames to an array
			Object[] objectArray2 = topicNameCollection.toArray();

			//Retrieving first BaseName from the array
			String utNavn2 = ((BaseName)(objectArray2[0])).getData();

			// Add the basename to the array containing all topic names
			topicNames[i] = utNavn2;

			//Incrementing counter i, and collecting next topic from objectArray[]
			j++;

		}while(j<numberOfTopics);


		// The topic names are put in a JComboBox
        topicType = new JComboBox(topicNames);
        topicType.addActionListener(this);

        //Listen to events from the buttons.
        addTopic.addActionListener(this);
        exitButton.addActionListener(this);

        //Add the widgets to the container.
        addTopicPanel.add(topicNameLabel);
        addTopicPanel.add(topicNameField);
        addTopicPanel.add(topicTypeLabel);
        addTopicPanel.add(topicType);
        addTopicPanel.add(addTopic);
        addTopicPanel.add(topicAddedLabel);
        addTopicPanel.add(exitButton);

        topicNameLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        topicAddedLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
    }

    public void actionPerformed(ActionEvent event) {

		// Get the name of the new topic
        String topicName = (String)(topicNameField.getText());

	    try{

			// Close window
	        if(event.getSource() == exitButton){
			   	System.out.println("Closing Add Topic Window");
			   	addTopicFrame.setVisible(false);
			}

			// Get topic type
			else if(event.getSource() == topicType){
				topicTypeExtracted = (JComboBox)event.getSource();
				String name = (String)topicTypeExtracted.getSelectedItem();
				System.out.println(name);
				topicTypeChosen = name;
				topicTypeSelected = true;
			}

			// Add the new topic

			else{

				// Add topic without topic type
        		if(topicTypeSelected == false){
        			// Create the new topic
        			testTopic = tm.createTopic(topicName);
        			// Make a basename for the topic
        			baseName = testTopic.createName("basename"+topicName);
        			// Set the value of the basename
        			baseName.setData(topicName);
        			// Add the basename to the topic
        			testTopic.addName(baseName);
        			// Print feedback to the user
	       		 	topicAddedLabel.setText("Topic " + topicName + " added.");

	       		 	// Add the new topic to the list off possible topic types
	       		 	topicType.addItem(topicName);
	       		 	topicType.repaint();
				}

				// Add topic with topic type
        		if(topicTypeSelected == true){
					topicTypeTopic = tm.getTopicByID(topicTypeChosen);
        			testTopic = tm.createTopic(topicName);
        			// Add the topic type
        			testTopic.addType(topicTypeTopic);
        			baseName = testTopic.createName("basename"+topicName);
        			baseName.setData(topicName);
        			testTopic.addName(baseName);
	       		 	topicAddedLabel.setText("Topic " + topicName + " added.");
	       		 	topicType.addItem(topicName);
	       		 	topicType.repaint();
				}

				// For test use
        		topicNameCollection = (Collection)baseNamesExtractor.fn(testTopic); //(Collection)
				System.out.println("Collection.size = " + topicNameCollection.size());
				Object[] testObjectArray = topicNameCollection.toArray();
				int arraySizeIs = java.lang.reflect.Array.getLength(testObjectArray);
				System.out.println("testObjectArray.size = " + arraySizeIs );
				String utNavn = ((BaseName)(testObjectArray[0])).getData();
				System.out.println(utNavn);

			}
		}

		catch(Exception ex){
			System.err.println(ex.toString());
		}

    }

    public void writeTopicMap(TopicMap tm, OutputStream os)
    {
		TopicMapWalker walker = new TopicMapWalker();
		XTMWriter writer = new XTMWriter();
		OutputFormat of = new OutputFormat();
		of.setEncoding("UTF-8");
		of.setIndenting(true);
		of.setIndent(2);
		XMLSerializer serializer = new XMLSerializer(os, of);
		walker.setHandler(writer);
		writer.setContentHandler(serializer);
		try
		{
		    walker.walk(tm);
		}
		catch(TopicMapProcessingException ex)
		{
		    throw new RuntimeException("Unable to write topic map." + ex.toString());
		}

    }

}

