/*
 * CreateTM.java
 */

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import java.io.*;
import java.net.*;
import java.util.*;

public class CreateTM{

	// Class variables

    public BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();
	public TopicMap tm = null;

    Collection topicNameCollection;

	public TopicMap create(){

		try{

			 // Create the new topic map

			 TopicMapProviderFactory tmpf = TopicMapProviderFactory.newInstance();
			 TopicMapProvider provider = tmpf.newTopicMapProvider(System.getProperties());
			 Locator base = provider.getLocatorFactory().createLocator("URI", "C:/Diplom/test.xtm");
			 tm = provider.createTopicMap(base);

			 // For test purposes

			 Topic topic = tm.createTopic("Frode");
			 BaseName baseName = topic.createName("Frode Hjeltnes");
        	 baseName.setData("Frode Hjeltnes");
        	 topic.addName(baseName);
        	 String nameString = baseName.getData();
        	 System.out.println(nameString);

			 // Console feedback

			 topicNameCollection = (Collection)baseNamesExtractor.fn(topic);
			 System.out.println("Collection.size = " + topicNameCollection.size());
			 int antallEmner = tm.getTopicCount();
			 System.out.println("Antall emner i emnekartet = " + antallEmner);

		 }
		catch(DuplicateObjectIDException ex){
			System.err.println("Error in creating topic: " + ex.toString());
		}
		catch(java.beans.PropertyVetoException ex){
			System.err.println(ex.toString());
		}

		catch(TopicMapProviderFactoryConfigurationError ex){
		 	System.err.println("Error in specification of provider factory: " + ex.toString());
		 }

		catch(TopicMapProviderException ex){
			System.err.println("Error creating back-end connection: " + ex.toString());
		}
		catch(LocatorFactoryException ex){
			System.out.println("Error creating locator: " + ex.getMessage());
		}

	return tm;
	}
}
