/**
 * ReadButton.java
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.memory.TopicMapProviderFactoryImpl;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.utils.extractors.*;
import org.tm4j.topicmap.utils.TopicMapWalker;
import org.tm4j.topicmap.utils.XTMWriter;

import java.io.FileNotFoundException;
import java.io.OutputStream;
import java.net.MalformedURLException;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;


public class ReadButton implements ActionListener {

	// Class variables

    JFrame converterFrame;
    JPanel converterPanel;
    JTextField tempCelsius;
    JLabel celsiusLabel, fahrenheitLabel;
    JButton addTopic;
    JButton assAdder;
    JButton intOccAdder;
    JButton exitButton;
    TopicMap tm = null;
    File outfile = null;
    FileOutputStream os = null;
	AddTopic2 at = null;
	AddIntOcc aio = null;
	AddAssociation aa = null;

    public ReadButton(TopicMap tutti) {

      	tm = tutti;

      	// Open the output file stream
      	try{
	      	outfile = new File("c:/diplom/egne eksempler/test.xtm");
	      	os = new FileOutputStream(outfile);
		}
		catch(java.lang.NullPointerException ex){
			System.err.println(ex.toString());
		}
		catch(FileNotFoundException ex){
			System.err.println(ex.toString());
		}

      // Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

      // Create and set up the window.
        converterFrame = new JFrame("QUIS Topic Map Builder");
        converterFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        converterFrame.setSize(new Dimension(120, 40));

        //Create and set up the panel.
        converterPanel = new JPanel(new GridLayout(4, 1));

        //Add the widgets.
        addWidgets();

        //Set the default button.
        converterFrame.getRootPane().setDefaultButton(exitButton);

        //Add the panel to the window.
        converterFrame.getContentPane().add(converterPanel, BorderLayout.CENTER);

        //Display the window.
        converterFrame.pack();
        converterFrame.setVisible(true);
    }

    /**
     * Create and add the widgets.
     */
    public void addWidgets() {

        addTopic = new JButton("Add Topic");
        assAdder = new JButton("Add Association");
		intOccAdder = new JButton("Add Occurrence");
    	exitButton = new JButton("Exit");

        // Listen to events from the buttons.
        addTopic.addActionListener(this);
        assAdder.addActionListener(this);
        intOccAdder.addActionListener(this);
        exitButton.addActionListener(this);

        // Add the widgets to the container.
        converterPanel.add(addTopic);
        converterPanel.add(assAdder);
        converterPanel.add(intOccAdder);
        converterPanel.add(exitButton);

    }

    public void actionPerformed(ActionEvent event) {

		// action performed when a button is pressed
        try{
			if(event.getSource() == addTopic){
	        	at = new AddTopic2();
	        	at.topicAdder(tm);
			}
			if(event.getSource() == intOccAdder){
				aio = new AddIntOcc();
				aio.intOccAdder(tm);
			}
			if(event.getSource() == assAdder){
				aa = new AddAssociation();
				aa.assAdder(tm);
			}
			if(event.getSource() == exitButton){
			   	System.out.println("Closing QUIS Topic Map Editor");
			   	converterFrame.setVisible(false);
			   	converterFrame.EXIT;

			}

			// Make sure the topic map is updated
			writeTopicMap(tm,os);

        	int antallEmner = tm.getTopicCount();
			System.out.println(antallEmner);
			System.out.println("topic map written");

		}
		catch(Exception ex){
			System.err.println(ex.toString());
		}

    }

    public void writeTopicMap(TopicMap tm, OutputStream os)
    {
	TopicMapWalker walker = new TopicMapWalker();
	XTMWriter writer = new XTMWriter();
	OutputFormat of = new OutputFormat();
	of.setEncoding("UTF-8");
	of.setIndenting(true);
	of.setIndent(2);
	XMLSerializer serializer = new XMLSerializer(os, of);
	walker.setHandler(writer);
	writer.setContentHandler(serializer);
	try{
	    walker.walk(tm);
	    }
	catch(TopicMapProcessingException ex){
	    throw new RuntimeException("Unable to write topic map." + ex.toString());
		}

    }

}



